import std/json, std/logging
import docopt

import wdiwtlt/private/cliconstants
import wdiwtlt/[cli, config, db]

when isMainModule:
 try:

  let args = docopt(USAGE, version = WDIWTLT_VERSION)

  let consoleLogger = newConsoleLogger(
    levelThreshold =
      if args["--debug"]: lvlDebug
      else: lvlInfo,
    fmtStr="pit - $levelname: ")
  logging.addHandler(consoleLogger)

  let cfg = loadConfig(args)

  if args["init-library"]:
    info "Initializing a new library database at '" & cfg.dbPath & "'"
    let newDb = initDb(cfg.dbPath)
    newDb.persist

    info "Writing configuration to '" & cfg.cfgPath & "'"
    cfg.cfgPath.writeFile(pretty(%*{
      "dbPath": cfg.dbPath,
      "libraryPath": cfg.libraryPath
    }))

    quit(0)

  startCli(cfg)

 except:
  fatal getCurrentExceptionMsg()
  debug getStackTrace(getCurrentException())
  quit(QuitFailure)
